"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectHash = _interopRequireDefault(require("object-hash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

const defaultSerializeKeyFunction = (parent, args, context, {
  parentType,
  fieldName
}) => {
  return (0, _objectHash.default)({
    parentType: parentType.toString(),
    fieldName,
    args
  });
};

const memoize = async (store, key, opts, resolver, {
  parent,
  args,
  context,
  info
}) => {
  const cacheKey = typeof key === 'function' ? await key(parent, args, context, info) : key;
  const cachedResult = await store.get(cacheKey);

  if (!cachedResult) {
    const result = await resolver(parent, args, context, info);
    const cached = store.set(cacheKey, result, opts);
    return result;
  }

  return cachedResult;
};

var _default = ({
  store: defaultStore = new Map(),
  key: defaultSerializeKey = defaultSerializeKeyFunction
} = {}) => {
  return {
    cache: (resolver, _ref = {}) => {
      let {
        store = defaultStore,
        key = defaultSerializeKey
      } = _ref,
          opts = _objectWithoutProperties(_ref, ["store", "key"]);

      return async (parent, args, context, info) => {
        return memoize(store, key, opts, resolver, {
          parent,
          args,
          context,
          info
        });
      };
    }
  };
};

exports.default = _default;